#ifndef MASKEDIT_H
#define MASKEDIT_H

#include <QPen>
#include <QPainter>
#include <QFrame>
#include <QMouseEvent>
#include <opencv2/opencv.hpp>

namespace Ui {
class MaskEdit;
}

class MaskEdit : public QFrame
{
    Q_OBJECT

public:
    explicit MaskEdit(const QRect geo, QWidget *parent = 0);
    ~MaskEdit();
    void updateFrame(cv::Mat *frame, std::vector<cv::Point> *points);
    void updateFrame(cv::Mat *frame);
    void updateFrame(std::vector<cv::Point> *points);
    virtual bool eventFilter(QObject *object, QEvent *ev) override;

private:
    Ui::MaskEdit *ui;
    cv::Mat *capture = nullptr;
    std::vector<cv::Point> *rectPoints = nullptr;
    int selectedCornerIndex = -1;

    // relative to the captured frame, not the UI
    float ratioX = 1.0f;
    float ratioY = 1.0f;

    int selectCorner(QMouseEvent* eMouse);
    void UpdateSelectedCornerPosition(QMouseEvent* eMouse);

protected:
    void paintEvent(QPaintEvent* event);

};

#endif // MASKEDIT_H
