#include "saveconfiggui.h"
#include "ui_saveconfiggui.h"

SaveConfigGui::SaveConfigGui(SandboxSetup *_setup, QWidget *parent) :
    SubApp("Finish configuration", "Failed to save configuration", parent),
    ui(new Ui::SaveConfigGui)
{
    setup = _setup;
    ui->setupUi(this);
}

SaveConfigGui::~SaveConfigGui()
{
    delete ui;
}

void SaveConfigGui::showEvent(QShowEvent *event){

    QWidget::showEvent(event);
    QTimer::singleShot(100, this, &SaveConfigGui::saveConfig);
}

void SaveConfigGui::saveConfig(){

    std::string msg = "Configuration saved !";
    if(setup->saveConfig()){
        msg = "Couldn't save the configuration.";
    }
    setup->getCamera()->stop();
    ui->lblMessage->setText(QString(msg.c_str()));
    emit sendNotif(0);
}
