#ifndef SANDBOX_FRAME_PROCESS_PROFIL_H
#define SANDBOX_FRAME_PROCESS_PROFIL_H

class FrameProcessProfil{
    private:
        // Profil to process on gray scaled images
        double contrast; // ]0, 255]
        int brightness; // [-2^16, 255]
        uint minDistance; // [1, 100] % of the frame's width
        uint cannyEdgeThreshold; // [0, 255] the strongest the contrast in the image is, the higher this param should be
        uint houghAccThreshold; // [0, n] where n = width*height of the frame
        uint minRadius; // [1, 100] % of the frame's width
        uint maxRadius; // [1, 100] % of the frame's width

    public:
        FrameProcessProfil(double c=1.0, int b=0, int d=15, uint cannyThreshold=100, uint accThreshold=50, uint minR=10, uint maxR=50){
            contrast = c;
            brightness = b;
            minDistance = d;
            cannyEdgeThreshold = cannyThreshold;
            houghAccThreshold = accThreshold;
            minRadius = minR;
            maxRadius = maxR;
        };
        double getContrast(){ return contrast; };
        void setContrast(double c){ contrast = c; };
        int getBrightness(){ return brightness; };
        void setBrightness(int b){ brightness = b; };
        uint getMinDistance(){ return minDistance; };
        void setMinDistance(uint d){ minDistance = d; };
        uint getCannyEdgeThreshold(){ return cannyEdgeThreshold; };
        void setCannyEdgeThreshold(uint cannyThreshold){ cannyEdgeThreshold = cannyThreshold; };
        uint getHoughAccThreshold(){ return houghAccThreshold; };
        void setHoughAccThreshold(uint accThreshold){ houghAccThreshold = accThreshold; };
        uint getMinRadius(){ return minRadius; };
        void setMinRadius(uint min){ minRadius = min; };
        uint getMaxRadius(){ return maxRadius; };
        void setMaxRadius(uint max){ maxRadius = max; };

        void setProfil(FrameProcessProfil p){
            contrast = p.getContrast();
            brightness = p.getBrightness();
            minDistance = p.getMinDistance();
            cannyEdgeThreshold = p.getCannyEdgeThreshold();
            houghAccThreshold = p.getHoughAccThreshold();
            minRadius = p.getMinRadius();
            maxRadius = p.getMaxRadius();
        }

        void print(){
            std::cout << contrast << std::endl;
            std::cout << brightness << std::endl;
            std::cout << minDistance << std::endl;
            std::cout << cannyEdgeThreshold << std::endl;
            std::cout << houghAccThreshold << std::endl;
            std::cout << minRadius << std::endl;
            std::cout << maxRadius << std::endl;
        }

};

#endif