#ifndef SANDBOX_H
#define SANDBOX_H

#include <opencv2/opencv.hpp>
#include "camera.h"
#include "projection.h"
#include "beamer.h"
#include "sandboxConfig.h"

class Sandbox{
    private:
        char *defaultConfigFilePath = (char *)"./sandbox_conf.yaml";
        Projection *projection;
        Camera *camera;
        Beamer *beamer;

    public:
        Sandbox();
        ~Sandbox();

        Camera* getCamera(){ return camera; };
        Beamer* getBeamer(){ return beamer; };
        Projection* getProjection(){ return projection; };

        int init();
        void captureFrame();
        cv::Mat_<cv::Vec3b> getColorFrame();
        cv::Mat_<float> getDepthFrame();
        cv::Mat_<cv::Vec3b> adjustProjection(cv::Mat_<cv::Vec3b> frame);
        int loadConfig();
        int loadConfigFrom(char *path);
    
};

#endif
